<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWiFiNetworkInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfWiFiNetworkInfo extends AbstractStructArrayBase
{
    /**
     * The WiFiNetworkInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\WiFiNetworkInfo[]
     */
    public $WiFiNetworkInfo;
    /**
     * Constructor method for ArrayOfWiFiNetworkInfo
     * @uses ArrayOfWiFiNetworkInfo::setWiFiNetworkInfo()
     * @param \CustomerManagement\StructType\WiFiNetworkInfo[] $wiFiNetworkInfo
     */
    public function __construct(array $wiFiNetworkInfo = array())
    {
        $this
            ->setWiFiNetworkInfo($wiFiNetworkInfo);
    }
    /**
     * Get WiFiNetworkInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\WiFiNetworkInfo[]|null
     */
    public function getWiFiNetworkInfo()
    {
        return isset($this->WiFiNetworkInfo) ? $this->WiFiNetworkInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWiFiNetworkInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWiFiNetworkInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWiFiNetworkInfoForArrayConstraintsFromSetWiFiNetworkInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWiFiNetworkInfoWiFiNetworkInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfWiFiNetworkInfoWiFiNetworkInfoItem instanceof \CustomerManagement\StructType\WiFiNetworkInfo) {
                $invalidValues[] = is_object($arrayOfWiFiNetworkInfoWiFiNetworkInfoItem) ? get_class($arrayOfWiFiNetworkInfoWiFiNetworkInfoItem) : sprintf('%s(%s)', gettype($arrayOfWiFiNetworkInfoWiFiNetworkInfoItem), var_export($arrayOfWiFiNetworkInfoWiFiNetworkInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WiFiNetworkInfo property can only contain items of type \CustomerManagement\StructType\WiFiNetworkInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WiFiNetworkInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\WiFiNetworkInfo[] $wiFiNetworkInfo
     * @return \CustomerManagement\ArrayType\ArrayOfWiFiNetworkInfo
     */
    public function setWiFiNetworkInfo(array $wiFiNetworkInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($wiFiNetworkInfoArrayErrorMessage = self::validateWiFiNetworkInfoForArrayConstraintsFromSetWiFiNetworkInfo($wiFiNetworkInfo))) {
            throw new \InvalidArgumentException($wiFiNetworkInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($wiFiNetworkInfo) || (is_array($wiFiNetworkInfo) && empty($wiFiNetworkInfo))) {
            unset($this->WiFiNetworkInfo);
        } else {
            $this->WiFiNetworkInfo = $wiFiNetworkInfo;
        }
        return $this;
    }
    /**
     * Add item to WiFiNetworkInfo value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\WiFiNetworkInfo $item
     * @return \CustomerManagement\ArrayType\ArrayOfWiFiNetworkInfo
     */
    public function addToWiFiNetworkInfo(\CustomerManagement\StructType\WiFiNetworkInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\WiFiNetworkInfo) {
            throw new \InvalidArgumentException(sprintf('The WiFiNetworkInfo property can only contain items of type \CustomerManagement\StructType\WiFiNetworkInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WiFiNetworkInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\WiFiNetworkInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\WiFiNetworkInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\WiFiNetworkInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\WiFiNetworkInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\WiFiNetworkInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WiFiNetworkInfo
     */
    public function getAttributeName()
    {
        return 'WiFiNetworkInfo';
    }
}
